﻿@model BeerOverflow.Web.Models.BeerViewModel
@using Microsoft.AspNetCore.Identity
@using BeerOverflow.Models
@using BeerOverflow.Services.DTOs


@inject SignInManager<User> SignInManager
@inject UserManager<User> UserManager
@inject BeerOverflow.Services.Contracts.IRatingService ratingService

@{
    ViewData["Title"] = "Beer Details";
}


<div class="py-5 bg-light">
    <div class="container">
        <div class="row mb-5">
            <div class="col-lg-6">
                <!-- PRODUCT SLIDER-->
                <div class="row m-sm-0">
                    <div class="col-sm-10 order-1 order-sm-2">
                        <div class="owl-carousel product-slider" data-slider-id="1">
                            <a class="d-block" data-lightbox="product" title="Product item 1"><img class="img-fluid" src="@Url.Content($"~/img/beers/beer{Model.Id}.jpg")" onerror='this.src="@Url.Content($"~/img/beers/defaultbeer.jpg")"'></a>
                        </div>
                    </div>
                </div>
            </div>
            <!-- PRODUCT DETAILS-->
            <div class="col-lg-6">
                <ul class="list-inline mb-2">
                    @for (int i = 0; i < await ratingService.Average(Model.Id); ++i)
                    {
                        <li class="list-inline-item m-0"><i class="fas fa-star small text-warning"></i></li>
                    }
                    @for (int i = 0; i < 5 - await ratingService.Average(Model.Id); ++i)
                    {
                        <li class="list-inline-item m-0"><i class="far fa-star small text-warning"></i></li>
                    }
                    <small class="text-gray"> (@await ratingService.Average(Model.Id, true) / 5) - [@await ratingService.Count(Model.Id) @(await ratingService.Count(Model.Id) == 1 ? "rating" : "ratings")]</small>
                </ul>
                <h1>@Model.Name</h1>
                <p class="text-muted lead">@Model.ABV</p>
                <p class="text-small mb-4">@Model.Description</p>
                <div class="row align-items-stretch mb-4">
                    <div class="col-sm-5 pr-sm-0">
                    </div>
                </div>
                <div>
                    <form asp-action="Add" asp-controller="WishList" method="post">
                        <input type="hidden" name="BeerId" value="@Model.Id" />
                        <button class="btn btn-link text-dark p-0 mb-4" type="submit">
                            <i class="far fa-heart mr-"></i>
                            Add to wish list
                        </button>
                    </form>
                    @if (User.IsInRole("Admin"))
                    {
                        <a class="btn btn-link text-dark p-0 mb-4" asp-controller="Beers" asp-action="Edit" asp-route-id="@Model.Id">
                            <i class="far fa-edit"></i>
                            Edit
                        </a>
                    }
                </div>
                <ul class="list-unstyled small d-inline-block">
                    <li class="px-3 py-2 mb-1 bg-white"><strong class="text-uppercase">BREWERY:</strong><span class="ml-2 text-muted">@Model.Brewery</span></li>
                    <li class="px-3 py-2 mb-1 bg-white"><strong class="text-uppercase">COUNTRY:</strong><span class="ml-2 text-muted">@Model.CountryName</span></li>
                    <li class="px-3 py-2 mb-1 bg-white"><strong class="text-uppercase">STYLE:</strong><span class="ml-2 text-muted">@Model.Style</span></li>
                </ul>
            </div>
        </div>
        <!-- DETAILS TABS-->
        <ul class="nav nav-tabs border-0" id="myTab" role="tablist">
            <li class="nav-item">
                <a class="nav-link active" id="description-tab" data-toggle="tab" href="#description" role="tab" aria-controls="description" aria-selected="true">Description</a>
            </li>
            <li class="nav-item">
                <a class="nav-link" id="reviews-tab" data-toggle="tab" href="#reviews" role="tab" aria-controls="reviews" aria-selected="false">Reviews</a>
            </li>
        </ul>
        <div class="tab-content mb-5" id="myTabContent">
            <div class="tab-pane fade show active" id="description" role="tabpanel" aria-labelledby="description-tab">
                <div class="p-4 p-lg-5 bg-white">
                    <h6 class="text-uppercase">Beer Description </h6>
                    <p class="text-muted text-small mb-0">@(Model.Description)</p>
                </div>
            </div>
            <div class="tab-pane fade" id="reviews" role="tabpanel" aria-labelledby="reviews-tab">
                <div class="p-4 p-lg-5 bg-white">
                    <div class="row">
                        <div class="col-lg-8">
                            @foreach (ReviewViewModel review in Model.Reviews)
                            {
                                <div class="media mb-3">
                                    <img class="rounded-circle" src="@Url.Content($"~/img/users/user{review.Name}.jpg")" alt="@Url.Content($"~/img/users/defaultuser.jpg")" width="50" onerror='this.src=alt'>
                                    <div class="media-body ml-3">
                                        <h6 class="mb-0 text-uppercase">@((SignInManager.IsSignedIn(User) && (await UserManager.GetUserAsync(User)).Name == review.Name) ? "You" : review.Name)</h6>
                                        <p class="small text-muted mb-0 text-uppercase">@review.Date</p>
                                        <ul class="list-inline mb-1 text-xs">
                                            @for (int i = 0; i < await ratingService.UserScore(Model.Id, review.UserID); ++i)
                                            {
                                                <li class="list-inline-item m-0"><i class="fas fa-star small text-warning"></i></li>
                                            }
                                            @for (int i = 0; i < 5 - await ratingService.UserScore(Model.Id, review.UserID); ++i)
                                            {
                                                <li class="list-inline-item m-0"><i class="far fa-star small text-warning"></i></li>
                                            }
                                        </ul>
                                        <p class="text-small mb-0 text-muted">@review.Body</p>
                                        <li class="list-inline-item">
                                            <form id="likeForm" asp-action="Like" asp-controller="Beers" asp-route-beerId=@Model.Id asp-route-reviewId=@review.ID asp method="post">
                                                <a class="nav-link" href="javascript:document.getElementById('likeForm').submit()" ><i class="far fa-thumbs-up"></i><small class="text-gray">  @review.Likes</small></a>
                                            </form>
                                        </li>
                                    </div>
                                </div>
                            }
                            <form asp-action="Review" asp-controller="Beers" asp-route-beerId=@Model.Id asp-route-userId=@UserManager.GetUserId(User) asp method="post">
                                <div class="text-danger"></div>
                                <div class="col-lg-6 form-group">
                                    <textarea id="reviewBody" name="reviewBody" rows="4" cols="60"></textarea>
                                    <select id="userRating" name="userRating" class="selectpicker ml-auto" data-width="200" data-style="bs-select-form-control" data-title="Rate the beer">
                                        <option value="1">1</option>
                                        <option value="2">2</option>
                                        <option value="3">3</option>
                                        <option value="4">4</option>
                                        <option value="5">5</option>
                                    </select>
                                </div>
                                <div class="col-lg-6 form-group">
                                    <input type="submit" value="Submit" class="btn btn-dark" />
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
